import { type Store } from "redux";
import { type SagaMiddleware } from "redux-saga";
import { LoggerImpl, type LoggerConfig, type Logger } from "./Logger";
import { type ActionHandler, type ErrorHandler } from "./module";
import { type State } from "./reducer";
interface App {
    readonly store: Store<State>;
    readonly sagaMiddleware: SagaMiddleware<any>;
    readonly actionHandlers: {
        [actionType: string]: ActionHandler;
    };
    readonly logger: LoggerImpl;
    loggerConfig: LoggerConfig | null;
    errorHandler: ErrorHandler;
}
export declare const app: App;
export declare const logger: Logger;
export {};
//# sourceMappingURL=app.d.ts.map